/***********************************************************************
Cpal.yacc source input file for yacc parser generator
main function located in cpal.lex file
***********************************************************************/

#include "lex.yy.c"
#include "include.h"
#include "funcs.h"
#include "tab.h"

#define YYDEBUG 0
#define YYSTYPE rettype


void funcs(A_node n)
{
   printf("%d\n",n->entity);
}

# define VAR 257
# define INT 258
# define REAL 259
# define STRING 260
# define BOOLE 261
# define ARRAY 262
# define OF 263
# define BEGN 264
# define END 265
# define READ 266
# define WRITE 267
# define IF 268
# define THEN 269
# define ELSE 270
# define WHILE 271
# define DO 272
# define RETURN 273
# define ID 274
# define NUM 275
# define FLOAT 276
# define STRLIT 277
# define OPNOT 278
# define OPMULT 279
# define OPDIV 280
# define OPMOD 281
# define OPADD 282
# define OPSUB 283
# define OPLT 284
# define OPGT 285
# define OPEQ 286
# define OPNEQ 287
# define OPLTE 288
# define OPGTE 289
# define OPOR 290
# define OPAND 291
# define OPSET 292
# define SEPRBK 293
# define SEPLBK 294
# define SEPLPAR 295
# define SEPRPAR 296
# define SEPCOL 297
# define SEPSEMI 298
# define SEPCOM 299
# define SEPDD 300
# define ERROR 301

#include <inttypes.h>

#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#define	YYCONST	const
#else
#include <malloc.h>
#include <memory.h>
#define	YYCONST
#endif

#include <values.h>

#if defined(__cplusplus) || defined(__STDC__)

#if defined(__cplusplus) && defined(__EXTERN_C__)
extern "C" {
#endif
#ifndef yyerror
#if defined(__cplusplus)
	void yyerror(YYCONST char *);
#endif
#endif
#ifndef yylex
	int yylex(void);
#endif
	int yyparse(void);
#if defined(__cplusplus) && defined(__EXTERN_C__)
}
#endif

#endif

#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256

static YYCONST yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 196,
	300, 28,
	-2, 23,
-1, 197,
	300, 26,
	-2, 24,
	};
# define YYNPROD 121
# define YYLAST 388
static YYCONST yytabelem yyact[]={

    33,    81,    82,    83,    73,   207,   206,   125,    75,    74,
    33,    81,    82,    83,    73,   174,   175,   148,    75,    74,
   125,    77,   103,   151,   130,   129,    33,    81,    82,    83,
    99,    77,   204,   193,    96,   181,   179,   131,    62,    61,
    60,    59,    58,    57,    47,     3,   133,    77,    98,   169,
   149,    51,   128,    65,    64,    48,   111,   110,   114,   115,
   113,   112,   184,    65,   205,   109,   150,   142,   143,   144,
   145,   146,    63,    92,   108,   116,   117,   208,   213,   214,
   197,   196,    51,   141,    81,    82,    83,   200,   203,   200,
   127,   139,   138,   118,   119,   120,     9,   154,    40,    41,
    36,    15,   155,    42,    85,    43,    33,    15,     9,    21,
    40,    41,    36,    52,     9,    42,    14,    43,    33,     9,
   189,    40,    41,    36,    14,    96,    42,     2,    43,    33,
     9,   173,    40,    41,    36,   126,     9,    42,   191,    43,
    33,     9,    51,    40,    41,    36,    14,   154,    42,   107,
    43,    33,   155,    81,    82,    83,   209,   202,   187,   142,
   143,   144,   145,   146,   201,   190,    15,    90,    54,    16,
   142,   143,   144,   145,     9,   136,   210,   198,    95,   153,
   194,    79,    80,   104,    78,    24,   134,   106,    86,    94,
    69,    32,    27,    68,    97,    93,    72,    76,    67,   105,
    39,    71,    38,    37,    35,    32,    27,    32,    27,    55,
    49,    56,    34,    31,    70,    30,     7,     6,    29,    17,
    28,    19,    84,    26,    66,    46,    23,    44,     5,    87,
    88,    89,    53,    25,    22,    91,    18,    20,    45,    11,
     8,   135,   199,   195,   137,    50,    13,    12,    10,     4,
     1,   100,   101,   102,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   124,     0,     0,     0,     0,
     0,   121,   122,   123,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   140,     0,     0,     0,     0,     0,    32,
    27,     0,   132,   152,   147,     0,     0,     0,     0,     0,
   157,     0,   156,     0,     0,     0,   176,     0,    32,    27,
   178,     0,   172,   170,   171,   166,   167,   168,   164,   165,
   180,   177,     0,   182,   183,   158,   159,   160,   161,   162,
   163,     0,   186,     0,     0,   185,     0,    32,    27,     0,
     0,   188,     0,     0,     0,     0,     0,     0,     0,     0,
   192,     0,     0,     0,     0,     0,     0,     0,   178,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   212,   215,   211 };
static YYCONST yytabelem yypact[]={

  -147,-10000000,  -253,  -150,   -96,   -90,-10000000,  -128,  -158,  -156,
   -91,   -90,  -254,-10000000,  -240,  -192,  -161,-10000000,   -90,-10000000,
-10000000,-10000000,   -97,  -123,-10000000,  -123,  -255,  -256,  -257,  -258,
  -259,  -260,  -220,  -241,-10000000,-10000000,  -264,-10000000,-10000000,-10000000,
  -170,  -264,  -264,  -264,-10000000,   -98,-10000000,-10000000,  -223,  -249,
  -269,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,  -264,  -274,  -264,  -120,  -216,  -226,  -228,
  -207,  -186,-10000000,  -248,  -248,  -248,-10000000,  -264,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,  -231,-10000000,  -292,  -137,-10000000,
  -184,  -244,  -273,  -261,-10000000,-10000000,  -192,  -251,  -191,  -192,
-10000000,  -279,  -246,-10000000,  -227,  -276,-10000000,  -168,  -264,  -264,
  -264,  -264,  -264,  -264,  -264,  -264,  -264,  -264,  -264,  -264,
  -264,-10000000,-10000000,-10000000,  -247,  -264,  -134,-10000000,  -282,-10000000,
   -88,  -132,  -262,   -99,-10000000,  -263,-10000000,-10000000,  -122,  -122,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,  -232,-10000000,-10000000,-10000000,
-10000000,  -264,  -118,-10000000,  -110,  -145,  -226,  -228,  -207,  -207,
  -207,  -207,  -207,  -207,  -186,  -186,-10000000,-10000000,-10000000,-10000000,
  -292,-10000000,  -100,  -133,   -88,-10000000,  -265,-10000000,-10000000,  -192,
-10000000,-10000000,-10000000,-10000000,  -194,-10000000,-10000000,-10000000,  -101,  -111,
  -183,-10000000,  -266,-10000000,  -229,  -293,-10000000,-10000000,  -295,-10000000,
  -198,  -112,-10000000,-10000000,-10000000,   -87,  -194,  -196,-10000000,-10000000,
   -88,-10000000,-10000000,-10000000,-10000000,-10000000 };
static YYCONST yytabelem yypgo[]={

     0,   250,   249,   228,   213,   216,   248,   247,   246,   194,
   186,   245,   175,   244,   180,   243,   177,   242,   241,   184,
   240,   239,   238,   235,   188,   187,   195,   189,   178,   234,
   185,   233,   223,   182,   220,   218,   215,   181,   212,   204,
   179,   203,   202,   200,   183,   199,   198,   193,   190,   214,
   201,   196,   197 };
static YYCONST yytabelem yyr1[]={

     0,     1,     2,     2,     2,     2,     5,     5,     6,     6,
     7,     9,     9,    11,    10,    10,    12,    12,    12,    12,
    13,    14,    14,    15,    15,    15,    16,    16,    17,    17,
     8,    18,    18,    18,    18,     3,     3,    20,    22,    21,
    21,    21,    21,    24,    24,    23,    23,    23,    26,    26,
    28,    27,     4,     4,    29,    29,    29,    30,    30,    31,
    31,    31,    31,    31,    31,    32,    33,    33,    33,    34,
    34,    38,    39,    39,    35,    35,    40,    40,    40,    36,
    36,    41,    41,    42,    42,    37,    37,    43,    44,    44,
    45,    25,    46,    46,    47,    47,    48,    48,    48,    48,
    48,    48,    48,    49,    49,    49,    50,    50,    50,    50,
    51,    51,    51,    51,    52,    52,    52,    52,    19,    19,
    19 };
static YYCONST yytabelem yyr2[]={

     0,    11,     5,     3,     7,     5,     3,     5,     5,     3,
     9,     3,     7,     3,     3,     3,     3,     3,     3,     3,
    13,     3,     7,     3,     3,     7,     3,     3,     3,     5,
    11,     5,     5,     3,     3,     3,     5,     9,     3,    15,
    11,     9,    13,     7,     7,     3,     3,     7,     7,     3,
     7,     5,     5,     7,     5,     3,     3,     5,     3,     5,
     5,     5,     5,     5,     5,     7,     9,     9,     7,     3,
     3,     5,     5,     5,    11,     9,     5,     9,     7,     3,
     3,    13,    11,     5,     3,     3,     3,     9,     3,     7,
     3,     3,     7,     3,     7,     3,     7,     7,     7,     7,
     7,     7,     3,     7,     7,     3,     7,     7,     7,     3,
     5,     5,     5,     3,     7,     3,     3,     3,     3,     3,
     3 };
static YYCONST yytabelem yychk[]={

-10000000,    -1,   274,   298,    -2,    -3,    -4,    -5,   -20,   264,
    -6,   -21,    -7,    -8,   274,   257,   265,    -4,    -3,    -4,
    -3,   265,   -29,    -5,   -30,   -31,   -32,   -33,   -34,   -35,
   -36,    -4,   -37,   274,   -38,   -39,   268,   -41,   -42,   -43,
   266,   267,   271,   273,    -5,   -22,    -4,   298,   295,    -9,
   -11,   274,   274,    -4,   265,   -30,   -30,   298,   298,   298,
   298,   298,   298,   292,   295,   294,   -25,   -46,   -47,   -48,
   -49,   -50,   -51,   278,   283,   282,   -52,   295,   -19,   -37,
   -33,   275,   276,   277,   -37,   274,   -24,   -25,   -25,   -25,
   265,   -23,   296,   -26,   -27,   -28,   257,    -9,   297,   299,
   -25,   -25,   -24,   296,   -44,   -45,   -25,   269,   290,   291,
   285,   284,   289,   288,   286,   287,   282,   283,   279,   280,
   281,   -52,   -52,   -52,   -25,   299,   272,   274,   296,   298,
   297,   298,   -26,   297,   -10,   -18,   -12,   -13,   283,   282,
   -19,   274,   258,   259,   260,   261,   262,    -9,   296,   296,
   293,   299,   -30,   -40,   265,   270,   -47,   -48,   -49,   -49,
   -49,   -49,   -49,   -49,   -50,   -50,   -51,   -51,   -51,   296,
   -25,   -24,   -30,   265,   297,   298,   -12,   -27,   -28,   298,
   -10,   298,   -19,   -19,   294,   -44,   -40,   268,   -30,   265,
   265,   271,   -12,   298,   -14,   -15,   275,   274,   -16,   -17,
   283,   265,   268,   271,   298,   293,   299,   300,   275,   268,
   263,   -14,   -16,   274,   275,   -12 };
static YYCONST yytabelem yydef[]={

     0,    -2,     0,     0,     0,     0,     3,     0,    35,     0,
     6,     0,     0,     9,     0,     0,     0,     2,     0,     5,
    36,    52,     0,    56,    55,    58,     0,     0,     0,     0,
     0,     0,     0,    85,    69,    70,     0,    79,    80,    86,
     0,     0,     0,    84,     7,     0,    38,     8,     0,     0,
    11,    13,     1,     4,    53,    54,    57,    59,    60,    61,
    62,    63,    64,     0,     0,     0,     0,    91,    93,    95,
   102,   105,   109,     0,     0,     0,   113,     0,   115,   116,
   117,   118,   119,   120,    71,    85,    72,    73,     0,    83,
     0,     0,     0,    45,    46,    49,     0,     0,     0,     0,
    65,     0,     0,    68,     0,    88,    90,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   110,   111,   112,     0,     0,     0,    37,     0,    41,
     0,     0,    51,     0,    10,     0,    14,    15,     0,     0,
    33,    34,    16,    17,    18,    19,     0,    12,    66,    67,
    87,     0,     0,    75,     0,     0,    92,    94,    96,    97,
    98,    99,   100,   101,   103,   104,   106,   107,   108,   114,
    43,    44,     0,     0,     0,    40,     0,    47,    48,     0,
    50,    30,    31,    32,     0,    89,    74,    76,     0,     0,
     0,    82,     0,    42,     0,    21,    -2,    -2,     0,    27,
     0,     0,    78,    81,    39,     0,     0,     0,    29,    77,
     0,    22,    25,    26,    28,    20 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{ char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"VAR",	257,
	"INT",	258,
	"REAL",	259,
	"STRING",	260,
	"BOOLE",	261,
	"ARRAY",	262,
	"OF",	263,
	"BEGN",	264,
	"END",	265,
	"READ",	266,
	"WRITE",	267,
	"IF",	268,
	"THEN",	269,
	"ELSE",	270,
	"WHILE",	271,
	"DO",	272,
	"RETURN",	273,
	"ID",	274,
	"NUM",	275,
	"FLOAT",	276,
	"STRLIT",	277,
	"OPNOT",	278,
	"OPMULT",	279,
	"OPDIV",	280,
	"OPMOD",	281,
	"OPADD",	282,
	"OPSUB",	283,
	"OPLT",	284,
	"OPGT",	285,
	"OPEQ",	286,
	"OPNEQ",	287,
	"OPLTE",	288,
	"OPGTE",	289,
	"OPOR",	290,
	"OPAND",	291,
	"OPSET",	292,
	"SEPRBK",	293,
	"SEPLBK",	294,
	"SEPLPAR",	295,
	"SEPRPAR",	296,
	"SEPCOL",	297,
	"SEPSEMI",	298,
	"SEPCOM",	299,
	"SEPDD",	300,
	"ERROR",	301,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"program : ID SEPSEMI body END ID",
	"body : sublist statementblock",
	"body : statementblock",
	"body : declist sublist statementblock",
	"body : declist statementblock",
	"declist : declaration",
	"declist : declaration declist",
	"declaration : vardec SEPSEMI",
	"declaration : constdec",
	"vardec : VAR idlist SEPCOL type",
	"idlist : ident",
	"idlist : ident SEPCOM idlist",
	"ident : ID",
	"type : base",
	"type : array",
	"base : INT",
	"base : REAL",
	"base : STRING",
	"base : BOOLE",
	"array : ARRAY SEPLBK range SEPRBK OF base",
	"range : subrange",
	"range : subrange SEPCOM range",
	"subrange : NUM",
	"subrange : ID",
	"subrange : idnum SEPDD idnum",
	"idnum : ID",
	"idnum : negnum",
	"negnum : NUM",
	"negnum : OPSUB NUM",
	"constdec : VAR idlist SEPCOL const SEPSEMI",
	"const : OPSUB numfloatstr",
	"const : OPADD numfloatstr",
	"const : numfloatstr",
	"const : ID",
	"sublist : sub",
	"sublist : sub sublist",
	"sub : subheading subbody END ID",
	"subbody : statementblock",
	"subheading : ID SEPLPAR arglist SEPRPAR SEPCOL base SEPSEMI",
	"subheading : ID SEPLPAR arglist SEPRPAR SEPSEMI",
	"subheading : ID SEPLPAR SEPRPAR SEPSEMI",
	"subheading : ID SEPLPAR SEPRPAR SEPCOL base SEPSEMI",
	"exprlist : expression SEPCOM expression",
	"exprlist : expression SEPCOM exprlist",
	"arglist : byvallist",
	"arglist : byreflist",
	"arglist : byvallist SEPSEMI byreflist",
	"byvallist : byvallist SEPSEMI listelem",
	"byvallist : listelem",
	"listelem : idlist SEPCOL type",
	"byreflist : VAR byvallist",
	"statementblock : BEGN END",
	"statementblock : BEGN blockbody END",
	"blockbody : declist statementlist",
	"blockbody : statementlist",
	"blockbody : declist",
	"statementlist : statement statementlist",
	"statementlist : statement",
	"statement : assignment SEPSEMI",
	"statement : subcalls SEPSEMI",
	"statement : io SEPSEMI",
	"statement : conditional SEPSEMI",
	"statement : flowctrl SEPSEMI",
	"statement : statementblock SEPSEMI",
	"assignment : variable OPSET expression",
	"subcalls : ID SEPLPAR expression SEPRPAR",
	"subcalls : ID SEPLPAR exprlist SEPRPAR",
	"subcalls : ID SEPLPAR SEPRPAR",
	"io : readio",
	"io : writeio",
	"readio : READ variable",
	"writeio : WRITE exprlist",
	"writeio : WRITE expression",
	"conditional : IF expression THEN statementlist ifend",
	"conditional : IF expression THEN ifend",
	"ifend : END IF",
	"ifend : ELSE statementlist END IF",
	"ifend : ELSE END IF",
	"flowctrl : whilestmt",
	"flowctrl : retstmt",
	"whilestmt : WHILE expression DO statementlist END WHILE",
	"whilestmt : WHILE expression DO END WHILE",
	"retstmt : RETURN expression",
	"retstmt : RETURN",
	"variable : ID",
	"variable : arrelement",
	"arrelement : ID SEPLBK scindex SEPRBK",
	"scindex : index",
	"scindex : index SEPCOM scindex",
	"index : expression",
	"expression : logic",
	"logic : logic OPOR andlog",
	"logic : andlog",
	"andlog : andlog OPAND relate",
	"andlog : relate",
	"relate : relate OPGT arith",
	"relate : relate OPLT arith",
	"relate : relate OPGTE arith",
	"relate : relate OPLTE arith",
	"relate : relate OPEQ arith",
	"relate : relate OPNEQ arith",
	"relate : arith",
	"arith : arith OPADD mult",
	"arith : arith OPSUB mult",
	"arith : mult",
	"mult : mult OPMULT unary",
	"mult : mult OPDIV unary",
	"mult : mult OPMOD unary",
	"mult : unary",
	"unary : OPNOT factor",
	"unary : OPSUB factor",
	"unary : OPADD factor",
	"unary : factor",
	"factor : SEPLPAR expression SEPRPAR",
	"factor : numfloatstr",
	"factor : variable",
	"factor : subcalls",
	"numfloatstr : NUM",
	"numfloatstr : FLOAT",
	"numfloatstr : STRLIT",
};
#endif /* YYDEBUG */
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)yaccpar	6.16	99/01/20 SMI"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yymaxdepth * sizeof (type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		yycvtok(yylex())
/*
** yycvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int yycvtok(int i)
#else
int yycvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( yymbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = yymbchars[mid].character;
			if( j==i ){/*Found*/ 
				return yymbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		yylex()
#endif/*!YYNMBCHARS*/

/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt = 0;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside
	switch should never be executed
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto yyerrlab;
		case 2: goto yynewstate;
	}
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
			yyerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */
	goto yystack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			long yyps_index = (yy_ps - yys);
			long yypv_index = (yy_pv - yyv);
			long yypvt_index = (yypvt - yyv);
			int yynewmax;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newyys = (char *)YYNEW(int);
				char *newyyv = (char *)YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
				yyerror( "yacc stack overflow" );
				YYABORT;
			}
			yymaxdepth = yynewmax;

			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register YYCONST int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
			skip_init:
				yynerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 1:{
		int i;
		yyval.u.anode=yypvt[-2].u.anode;
		yyval.u.anode->lineno=yypvt[-4].lineno;
		yyval.u.anode->u.decl.id=(char *)malloc(strlen(yypvt[-4].u.strval)+1);
		strcpy(yyval.u.anode->u.decl.id,yypvt[-4].u.strval);
		if (strcmp(yypvt[-4].u.strval,yypvt[-0].u.strval)!=0){
		  printf("Error[%d], program %s does not match %s.\n",yypvt[-4].lineno,yypvt[-4].u.strval,yypvt[-0].u.strval);
                globerr=-1;
                }
		travprg(yyval.u.anode);
		/*printf("\nCompiler returned [%d]\n",globerr);*/
#ifndef source_list_off
		printf("\n************** Source Listing **************\n");
		prtprg(yyval.u.anode);
		printf("\n");
#endif
		} break;
case 2:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=yypvt[-1].u.anode->lineno;
		node->u.decl.kind=progDecl;
		node->u.decl.id=NULL;
		node->u.decl.u.prog.declist=NULL;
		node->u.decl.u.prog.subdecl=yypvt[-1].u.anode;
		node->u.decl.u.prog.stmtblk=yypvt[-0].u.anode;
		node->u.decl.next=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 3:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=yypvt[-0].u.anode->lineno;
		node->u.decl.kind=progDecl;
		node->u.decl.id=NULL;
		node->u.decl.u.prog.declist=NULL;
		node->u.decl.u.prog.subdecl=NULL;
		node->u.decl.u.prog.stmtblk=yypvt[-0].u.anode;
		node->u.decl.next=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 4:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=yypvt[-2].u.anode->lineno;
		node->u.decl.kind=progDecl;
		node->u.decl.id=NULL;
		node->u.decl.u.prog.declist=yypvt[-2].u.anode;
		node->u.decl.u.prog.subdecl=yypvt[-1].u.anode;
		node->u.decl.u.prog.stmtblk=yypvt[-0].u.anode;
		node->u.decl.next=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 5:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=yypvt[-1].u.anode->lineno;
		node->u.decl.kind=progDecl;
		node->u.decl.id=NULL;
		node->u.decl.u.prog.declist=yypvt[-1].u.anode;
		node->u.decl.u.prog.subdecl=NULL;
		node->u.decl.u.prog.stmtblk=yypvt[-0].u.anode;
		node->u.decl.next=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 6:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 7:{
		yyval.u.anode=yypvt[-1].u.anode;
		yyval.u.anode->u.decl.next=yypvt[-0].u.anode;
		} break;
case 8:{
		yyval.u.anode=yypvt[-1].u.anode;
		} break;
case 9:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 10:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=yypvt[-3].lineno;
		node->u.decl.kind=varDecl;
		node->u.decl.id=NULL;
		node->u.decl.u.var.idList=yypvt[-2].u.anode;
		node->u.decl.u.var.typ=yypvt[-0].u.anode;
		node->u.decl.next=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 11:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 12:{
		yyval.u.anode=yypvt[-2].u.anode;
		yyval.u.anode->u.idlist.next=yypvt[-0].u.anode;
		} break;
case 13:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=idTag;
		node->lineno=yypvt[-0].lineno;
		node->u.idlist.id=(char *)malloc(strlen(yypvt[-0].u.strval)+1);
		strcpy(node->u.idlist.id,yypvt[-0].u.strval);
		node->u.idlist.next=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 14:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 15:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 16:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=typTag;
		node->lineno=yypvt[-0].lineno;
		node->u.typ.kind=baseTy;
		node->u.typ.base=intTy;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 17:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=typTag;
		node->lineno=yypvt[-0].lineno;
		node->u.typ.kind=baseTy;
		node->u.typ.base=realTy;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 18:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=typTag;
		node->lineno=yypvt[-0].lineno;
		node->u.typ.kind=baseTy;
		node->u.typ.base=strTy;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 19:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=typTag;
		node->lineno=yypvt[-0].lineno;
		node->u.typ.kind=baseTy;
		node->u.typ.base=boolTy;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 20:{
		yyval.u.anode=yypvt[-3].u.anode;
		yyval.u.anode->u.typ.base=yypvt[-0].u.anode->u.typ.base;
		free(yypvt[-0].u.anode);
		} break;
case 21:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 22:{
		yyval.u.anode=yypvt[-2].u.anode;
		yyval.u.anode->next=yypvt[-0].u.anode;
		} break;
case 23:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=typTag;
		node->lineno=yypvt[-0].lineno;
		node->u.typ.kind=array1Ty;
		node->u.typ.base1=inttyp;
		node->u.typ.r1.num=yypvt[-0].u.intval;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 24:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=typTag;
		node->lineno=yypvt[-0].lineno;
		node->u.typ.kind=array1Ty;
		node->u.typ.base1=consttyp;
		node->u.typ.r1.id=(char *)malloc(strlen(yypvt[-0].u.strval)+1);
		strcpy(node->u.typ.r1.id,yypvt[-0].u.strval);
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 25:{
		yyval.u.anode=yypvt[-2].u.anode;
		yyval.u.anode->u.typ.kind=array2Ty;
		yyval.u.anode->u.typ.base2=yypvt[-0].u.anode->u.typ.base1;
		switch (yypvt[-0].u.anode->u.typ.base1)
		{
		case inttyp:
		case subinttyp:
		  yyval.u.anode->u.typ.r2.num=yypvt[-0].u.anode->u.typ.r1.num;
		  break;
		case consttyp:
		  yyval.u.anode->u.typ.r2.id=yypvt[-0].u.anode->u.typ.r1.id;
		  break;
		default:
		  printf("Error[%d]!!, invalid type.%d\n",yypvt[-2].lineno,yypvt[-0].u.anode->u.typ.base1);
                  globerr=-1;
		}
		free(yypvt[-0].u.anode);
		} break;
case 26:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=typTag;
		node->lineno=yypvt[-0].lineno;
		node->u.typ.kind=array1Ty;
		node->u.typ.base1=consttyp;
		node->u.typ.r1.id=(char *)malloc(strlen(yypvt[-0].u.strval)+1);
		strcpy(node->u.typ.r1.id,yypvt[-0].u.strval);
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 27:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 28:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=typTag;
		node->lineno=yypvt[-0].lineno;
		node->u.typ.kind=array1Ty;
		node->u.typ.base1=inttyp;
		node->u.typ.r1.num=yypvt[-0].u.intval;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 29:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=typTag;
		node->lineno=yypvt[-1].lineno;
		node->u.typ.kind=array1Ty;
		node->u.typ.base1=subinttyp;
		node->u.typ.r1.num=yypvt[-0].u.intval;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 30:{
		yyval.u.anode=yypvt[-1].u.anode;
		yyval.u.anode->u.decl.u.cnst.idList=yypvt[-3].u.anode;
		} break;
case 31:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=yypvt[-1].lineno;
		node->u.decl.kind=constDecl;
		node->u.decl.id=NULL;
		switch (yypvt[-0].u.anode->u.oper.kind)
		{
		case number:	
		  node->u.decl.u.cnst.kind=subinttyp;
		  node->u.decl.u.cnst.val.intval=yypvt[-0].u.anode->u.oper.u.intval;
		  break;
		case real:
		  node->u.decl.u.cnst.kind=subrealtyp;
		  node->u.decl.u.cnst.val.realval=yypvt[-0].u.anode->u.oper.u.realval;
		  break;
		case str:
		  printf("Error[%d], invalid '-' before string\n",yypvt[-1].lineno);
                  globerr=-1;
		  node->u.decl.u.cnst.kind=strtyp;
		  node->u.decl.u.cnst.val.strval=yypvt[-0].u.anode->u.oper.u.strval;
		  break;
		default:
		  printf("Error! Invalid type.\n");
                  globerr=-1;
		}
		node->u.decl.u.cnst.idList=NULL;
		node->u.decl.next=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 32:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=yypvt[-1].lineno;
		node->u.decl.kind=constDecl;
		node->u.decl.id=NULL;
		switch (yypvt[-0].u.anode->u.oper.kind)
		{
		case number:	
		  node->u.decl.u.cnst.kind=addinttyp;
		  node->u.decl.u.cnst.val.intval=yypvt[-0].u.anode->u.oper.u.intval;
		  break;
		case real:
		  node->u.decl.u.cnst.kind=addrealtyp;
		  node->u.decl.u.cnst.val.realval=yypvt[-0].u.anode->u.oper.u.realval;
		  break;
		case str:
		  printf("Error[%d], invalid '+' before string\n",yypvt[-1].lineno);
                  globerr=-1;
		  node->u.decl.u.cnst.kind=strtyp;
		  node->u.decl.u.cnst.val.strval=yypvt[-0].u.anode->u.oper.u.strval;
		  break;
		default:
		  printf("Error! Invalid type.\n");
                  globerr=-1;
		}
		node->u.decl.u.cnst.idList=NULL;
		node->u.decl.next=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 33:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=yypvt[-0].u.anode->lineno;
		node->u.decl.kind=constDecl;
		node->u.decl.id=NULL;
		switch (yypvt[-0].u.anode->u.oper.kind)
		{
		case number:	
		  node->u.decl.u.cnst.kind=inttyp;
		  node->u.decl.u.cnst.val.intval=yypvt[-0].u.anode->u.oper.u.intval;
		  break;
		case real:
		  node->u.decl.u.cnst.kind=realtyp;
		  node->u.decl.u.cnst.val.realval=yypvt[-0].u.anode->u.oper.u.realval;
		  break;
		case str:
		  node->u.decl.u.cnst.kind=strtyp;
		  node->u.decl.u.cnst.val.strval=yypvt[-0].u.anode->u.oper.u.strval;
		  break;
		default:
		  printf("Error! Invalid type.\n");
                  globerr=-1;
		}
		node->u.decl.u.cnst.idList=NULL;
		node->u.decl.next=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 34:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=yypvt[-0].lineno;
		node->u.decl.kind=constDecl;
		node->u.decl.id=(char *)malloc(strlen(yypvt[-0].u.strval)+1);
		strcpy(node->u.decl.id,yypvt[-0].u.strval);
		node->u.decl.u.cnst.kind=consttyp;
		node->u.decl.u.cnst.idList=NULL;
		node->u.decl.next=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 35:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 36:{
		yyval.u.anode=yypvt[-1].u.anode;
		yyval.u.anode->u.decl.u.sub.next=yypvt[-0].u.anode;
		} break;
case 37:{
		yyval.u.anode=yypvt[-3].u.anode;
		yyval.u.anode->u.decl.u.sub.stmtblk=yypvt[-2].u.anode;
		if(strcmp(yypvt[-3].u.anode->u.decl.id,yypvt[-0].u.strval)!=0){
		  printf("Error[%d], sub %s declaration ended with %s.\n",yypvt[-3].lineno,yypvt[-3].u.anode->u.decl.id, yypvt[-0].u.strval);
                  globerr=-1;
                }
		} break;
case 38:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 39:{
		yyval.u.anode=yypvt[-4].u.anode;
		yyval.u.anode->lineno=yypvt[-6].lineno;
		yyval.u.anode->u.decl.id=(char *)malloc(strlen(yypvt[-6].u.strval)+1);
		strcpy(yyval.u.anode->u.decl.id,yypvt[-6].u.strval);
		yyval.u.anode->u.decl.u.sub.rettype=yypvt[-1].u.anode;
		} break;
case 40:{
		yyval.u.anode=yypvt[-2].u.anode;
		yyval.u.anode->lineno=yypvt[-4].lineno;
		yyval.u.anode->u.decl.id=(char *)malloc(strlen(yypvt[-4].u.strval)+1);
		strcpy(yyval.u.anode->u.decl.id,yypvt[-4].u.strval);
		} break;
case 41:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=yypvt[-3].lineno;
		node->u.decl.kind=subroutineDecl;
		node->u.decl.id=(char *)malloc(strlen(yypvt[-3].u.strval)+1);
		strcpy(node->u.decl.id,yypvt[-3].u.strval);
		node->u.decl.u.sub.reflist=NULL;
		node->u.decl.u.sub.vallist=NULL;
		node->u.decl.u.sub.stmtblk=NULL;
		node->u.decl.u.sub.rettype=NULL;
		node->u.decl.next=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 42:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=yypvt[-5].lineno;
		node->u.decl.kind=subroutineDecl;
		node->u.decl.id=(char *)malloc(strlen(yypvt[-5].u.strval)+1);
		strcpy(node->u.decl.id,yypvt[-5].u.strval);
		node->u.decl.u.sub.reflist=NULL;
		node->u.decl.u.sub.vallist=NULL;
		node->u.decl.u.sub.stmtblk=NULL;
		node->u.decl.u.sub.rettype=yypvt[-1].u.anode;
		node->u.decl.next=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 43:{
		yyval.u.anode=yypvt[-2].u.anode;
		yyval.u.anode->next=yypvt[-0].u.anode;
		} break;
case 44:{
		yyval.u.anode=yypvt[-2].u.anode;
		yyval.u.anode->next=yypvt[-0].u.anode;
		} break;
case 45:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=yypvt[-0].u.anode->lineno;
		node->u.decl.kind=subroutineDecl;
		node->u.decl.id=NULL;
		node->u.decl.u.sub.reflist=NULL;
		node->u.decl.u.sub.vallist=yypvt[-0].u.anode;
		node->u.decl.u.sub.stmtblk=NULL;
		node->u.decl.u.sub.rettype=NULL;
		node->u.decl.next=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 46:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=yypvt[-0].u.anode->lineno;
		node->u.decl.kind=subroutineDecl;
		node->u.decl.id=NULL;
		node->u.decl.u.sub.reflist=yypvt[-0].u.anode;
		node->u.decl.u.sub.vallist=NULL;
		node->u.decl.u.sub.stmtblk=NULL;
		node->u.decl.u.sub.rettype=NULL;
		node->u.decl.next=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 47:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=yypvt[-2].u.anode->lineno;
		node->u.decl.kind=subroutineDecl;
		node->u.decl.id=NULL;
		node->u.decl.u.sub.reflist=yypvt[-0].u.anode;
		node->u.decl.u.sub.vallist=yypvt[-2].u.anode;
		node->u.decl.u.sub.stmtblk=NULL;
		node->u.decl.u.sub.rettype=NULL;
		node->u.decl.next=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 48:{
		A_node idx;
		yyval.u.anode=yypvt[-2].u.anode;
		idx=yyval.u.anode;	//initializes index
		while(idx->u.decl.next!=NULL)
		  idx=idx->u.decl.next;	//traverses list
		idx->u.decl.next=yypvt[-0].u.anode;	//adds element at end of list
		} break;
case 49:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 50:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=yypvt[-2].u.anode->lineno;
		node->u.decl.kind=varDecl;
		node->u.decl.id=NULL;
		node->u.decl.u.var.idList=yypvt[-2].u.anode;
		node->u.decl.u.var.typ=yypvt[-0].u.anode;
		node->u.decl.next=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 51:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 52:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=yypvt[-1].lineno;
		node->u.stmt.kind=stmtblk;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 53:{
		yyval.u.anode=yypvt[-1].u.anode;
		} break;
case 54:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=yypvt[-1].u.anode->lineno;
		node->u.stmt.kind=stmtblk;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=yypvt[-1].u.anode;
		node->u.stmt.stmtlist=yypvt[-0].u.anode;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 55:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=yypvt[-0].u.anode->lineno;
		node->u.stmt.kind=stmtblk;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=yypvt[-0].u.anode;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 56:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=yypvt[-0].u.anode->lineno;
		node->u.stmt.kind=stmtblk;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=yypvt[-0].u.anode;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 57:{
		yyval.u.anode=yypvt[-1].u.anode;
		yyval.u.anode->next=yypvt[-0].u.anode;
		} break;
case 58:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 59:{
		yyval.u.anode=yypvt[-1].u.anode;
		} break;
case 60:{
		yyval.u.anode=yypvt[-1].u.anode;
		} break;
case 61:{
		yyval.u.anode=yypvt[-1].u.anode;
		} break;
case 62:{
		yyval.u.anode=yypvt[-1].u.anode;
		} break;
case 63:{
		yyval.u.anode=yypvt[-1].u.anode;
		} break;
case 64:{
		yyval.u.anode=yypvt[-1].u.anode;
		} break;
case 65:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=yypvt[-2].u.anode->lineno;
		node->u.stmt.kind=assignstmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=yypvt[-2].u.anode;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=yypvt[-0].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 66:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=yypvt[-3].lineno;
		node->u.stmt.kind=subcalls;
		node->u.stmt.id=(char *)malloc(strlen(yypvt[-3].u.strval)+1);
		strcpy(node->u.stmt.id,yypvt[-3].u.strval);
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=yypvt[-1].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 67:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=yypvt[-3].lineno;
		node->u.stmt.kind=subcalls;
		node->u.stmt.id=(char *)malloc(strlen(yypvt[-3].u.strval)+1);
		strcpy(node->u.stmt.id,yypvt[-3].u.strval);
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=yypvt[-1].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 68:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=yypvt[-2].lineno;
		node->u.stmt.kind=subcalls;
		node->u.stmt.id=(char *)malloc(strlen(yypvt[-2].u.strval)+1);
		strcpy(node->u.stmt.id,yypvt[-2].u.strval);
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 69:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 70:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 71:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=yypvt[-1].lineno;
		node->u.stmt.kind=readstmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=yypvt[-0].u.anode;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 72:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=yypvt[-1].lineno;
		node->u.stmt.kind=writestmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=yypvt[-0].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 73:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=yypvt[-1].lineno;
		node->u.stmt.kind=writestmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=yypvt[-0].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 74:{
		yyval.u.anode=yypvt[-0].u.anode;
		yyval.u.anode->lineno=yypvt[-4].lineno;
		yyval.u.anode->u.stmt.exprlist=yypvt[-3].u.anode;
		yyval.u.anode->u.stmt.stmtlist=yypvt[-1].u.anode;
		} break;
case 75:{
		yyval.u.anode=yypvt[-0].u.anode;
		yyval.u.anode->lineno=yypvt[-3].lineno;
		yyval.u.anode->u.stmt.exprlist=yypvt[-2].u.anode;
		} break;
case 76:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=yypvt[-1].lineno;
		node->u.stmt.kind=ifstmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 77:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=yypvt[-3].lineno;
		node->u.stmt.kind=ifstmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=yypvt[-2].u.anode;
		node->u.stmt.exprlist=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 78:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=yypvt[-2].lineno;
		node->u.stmt.kind=ifstmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 79:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 80:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 81:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=yypvt[-5].lineno;
		node->u.stmt.kind=whilestmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=yypvt[-2].u.anode;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=yypvt[-4].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 82:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=yypvt[-4].lineno;
		node->u.stmt.kind=whilestmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=yypvt[-3].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 83:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=yypvt[-1].lineno;
		node->u.stmt.kind=returnstmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=yypvt[-0].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 84:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=yypvt[-0].lineno;
		node->u.stmt.kind=returnstmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 85:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=varTag;
		node->lineno=yypvt[-0].lineno;
		node->u.var.kind=varvar;
		node->u.var.id=(char *)malloc(strlen(yypvt[-0].u.strval)+1);
		strcpy(node->u.var.id,yypvt[-0].u.strval);
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 86:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 87:{
		yyval.u.anode=yypvt[-1].u.anode;
		yyval.u.anode->u.var.id=(char *)malloc(strlen(yypvt[-3].u.strval)+1);
		strcpy(yyval.u.anode->u.var.id, yypvt[-3].u.strval);
		yyval.u.anode->u.var.kind=arrvar;
		} break;
case 88:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 89:{
		yyval.u.anode=yypvt[-2].u.anode;
		yyval.u.anode->u.var.idxlist.next=yypvt[-0].u.anode;
		} break;
case 90:{
                A_node node;
                node=(A_node)malloc(sizeof(struct A_Node));
                node->entity=varTag;
                node->lineno=yypvt[-0].lineno;
                node->u.var.idxlist.expr=yypvt[-0].u.anode;
                node->u.var.idxlist.next=NULL;
                node->u.var.id=NULL;
                node->next=NULL;
                yyval.u.anode=node;
		} break;
case 91:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=yypvt[-0].u.anode->lineno;
		node->u.expr.kind=ex;
		node->u.expr.operand1=yypvt[-0].u.anode;
		node->u.expr.operand2=NULL;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 92:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=yypvt[-2].u.anode->lineno;
		node->u.expr.kind=or;
		node->u.expr.operand1=yypvt[-2].u.anode;
		node->u.expr.operand2=yypvt[-0].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 93:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 94:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=yypvt[-2].u.anode->lineno;
		node->u.expr.kind=and;
		node->u.expr.operand1=yypvt[-2].u.anode;
		node->u.expr.operand2=yypvt[-0].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 95:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 96:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=yypvt[-2].u.anode->lineno;
		node->u.expr.kind=gt;
		node->u.expr.operand1=yypvt[-2].u.anode;
		node->u.expr.operand2=yypvt[-0].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 97:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=yypvt[-2].u.anode->lineno;
		node->u.expr.kind=lt;
		node->u.expr.operand1=yypvt[-2].u.anode;
		node->u.expr.operand2=yypvt[-0].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 98:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=yypvt[-2].u.anode->lineno;
		node->u.expr.kind=gteq;
		node->u.expr.operand1=yypvt[-2].u.anode;
		node->u.expr.operand2=yypvt[-0].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 99:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=yypvt[-2].u.anode->lineno;
		node->u.expr.kind=lteq;
		node->u.expr.operand1=yypvt[-2].u.anode;
		node->u.expr.operand2=yypvt[-0].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 100:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=yypvt[-2].u.anode->lineno;
		node->u.expr.kind=eq;
		node->u.expr.operand1=yypvt[-2].u.anode;
		node->u.expr.operand2=yypvt[-0].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 101:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=yypvt[-2].u.anode->lineno;
		node->u.expr.kind=neq;
		node->u.expr.operand1=yypvt[-2].u.anode;
		node->u.expr.operand2=yypvt[-0].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 102:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 103:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=yypvt[-2].u.anode->lineno;
		node->u.expr.kind=add;
		node->u.expr.operand1=yypvt[-2].u.anode;
		node->u.expr.operand2=yypvt[-0].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 104:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=yypvt[-2].u.anode->lineno;
		node->u.expr.kind=sub;
		node->u.expr.operand1=yypvt[-2].u.anode;
		node->u.expr.operand2=yypvt[-0].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 105:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 106:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=yypvt[-2].u.anode->lineno;
		node->u.expr.kind=mult;
		node->u.expr.operand1=yypvt[-2].u.anode;
		node->u.expr.operand2=yypvt[-0].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 107:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=yypvt[-2].u.anode->lineno;
		node->u.expr.kind=divide;
		node->u.expr.operand1=yypvt[-2].u.anode;
		node->u.expr.operand2=yypvt[-0].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 108:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=yypvt[-2].u.anode->lineno;
		node->u.expr.kind=mod;
		node->u.expr.operand1=yypvt[-2].u.anode;
		node->u.expr.operand2=yypvt[-0].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 109:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 110:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=yypvt[-1].lineno;
		node->u.expr.kind=not;
		node->u.expr.operand1=NULL;
		node->u.expr.operand2=yypvt[-0].u.anode;
		node->next=NULL;
		yyval.u.anode=node;		
		} break;
case 111:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=yypvt[-1].lineno;
		node->u.expr.kind=sub;
		node->u.expr.operand1=NULL;
		node->u.expr.operand2=yypvt[-0].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 112:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=yypvt[-1].lineno;
		node->u.expr.kind=add;
		node->u.expr.operand1=NULL;
		node->u.expr.operand2=yypvt[-0].u.anode;
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 113:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 114:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=operTag;
		node->lineno=yypvt[-2].lineno;
		node->u.oper.kind=expr;
		node->u.oper.u.expr=yypvt[-1].u.anode;	
		node->next=NULL;
		yyval.u.anode=node;		
		} break;
case 115:{
		yyval.u.anode=yypvt[-0].u.anode;
		} break;
case 116:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=operTag;
		node->lineno=yypvt[-0].u.anode->lineno;
		node->u.oper.kind=variable;
		node->u.oper.u.var=yypvt[-0].u.anode;	
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 117:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=operTag;
		node->lineno=yypvt[-0].u.anode->lineno;
		node->u.oper.kind=subcall;
		node->u.oper.u.subcall=yypvt[-0].u.anode;	
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 118:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=operTag;
		node->lineno=yypvt[-0].lineno;
		node->u.oper.kind=number;
		node->u.oper.u.intval=yypvt[-0].u.intval;	
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 119:{	
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=operTag;
		node->lineno=yypvt[-0].lineno;
		node->u.oper.kind=real;
		node->u.oper.u.realval=yypvt[-0].u.realval;	
		node->next=NULL;
		yyval.u.anode=node;
		} break;
case 120:{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=operTag;
		node->lineno=yypvt[-0].lineno;
		node->u.oper.kind=str;
		node->u.oper.u.strval=yypvt[-0].u.strval;	
		node->next=NULL;
		yyval.u.anode=node;
		} break;
	}
	goto yystack;		/* reset registers in driver code */
}

